<template>
    <div class="app-container">
        <!--    <el-form :model="queryParams" ref="queryForm" @submit.native.prevent :inline="true" v-show="showSearch" label-width="68px">-->
        <!--      <el-form-item label="账单标题" prop="title">-->
        <!--        <el-input v-model="queryParams.title" placeholder="请输入账单标题" clearable-->
        <!--                  @keyup.enter.native="handleQuery"/>-->
        <!--      </el-form-item>-->
        <!--      <el-form-item label="开始时间">-->
        <!--        <el-date-picker-->
        <!--          v-model="monthTime"-->
        <!--          value-format="yyyy-MM"-->
        <!--          type="month"-->
        <!--          placeholder="选择月"-->
        <!--        >-->
        <!--        </el-date-picker>-->
        <!--      </el-form-item>-->
        <!--      <el-form-item>-->
        <!--        <el-button type="primary" icon="el-icon-search"   @click="handleQuery">搜索</el-button>-->
        <!--        <el-button icon="el-icon-refresh"   @click="resetQuery">重置</el-button>-->
        <!--      </el-form-item>-->
        <!--    </el-form>-->
        <!--    <el-row :gutter="10" class="mb8">-->
        <!--      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>-->
        <!--    </el-row>-->

        <el-table v-loading="loading" fit highlight-current-row border stripe :data="billList" @selection-change="handleSelectionChange">
            <el-table-column label="账单标题" align="center" prop="title" />
            <el-table-column label="工厂名称" align="center" prop="orgName" width="130px"> </el-table-column>
            <el-table-column label="开始时间" align="center" prop="beginTime" width="100px" />
            <el-table-column label="结束时间" align="center" prop="endTime" width="100px" />
            <el-table-column label="总交易金额（元）" align="center" prop="totalTransactionAmount" width="130px" />
            <el-table-column label="总交易件数（件）" align="center" prop="totalTransactionNum" width="130px" />
            <el-table-column label="工厂结算金额（元）" align="center" prop="factorySettlementAmount" width="150px" />
            <el-table-column label="材料费（元）" align="center" prop="materialAmount" width="100px" />
            <el-table-column label="管理费（元）" align="center" prop="manageAmount" width="100px" />
            <el-table-column label="实际收入（元）" align="center" prop="realIncomeAmount" width="120px" />
            <el-table-column label="备注" align="center" prop="remark" width="120px" >
                <template slot-scope="scope">
                    {{ scope.row.remark || "--" }}
                </template>
                </el-table-column>
            <el-table-column label="状态" align="center" prop="status">
                <template slot-scope="scope">
                    <dict-tag :options="dict.type.settlement_status_type" :value="scope.row.status" />
                </template>
            </el-table-column>
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="150">
                <template slot-scope="scope">
                    <el-button type="text" @click="confirmSettlement(scope.row)" v-if="scope.row.status == '0'">确认清算</el-button>
                </template>
            </el-table-column>
        </el-table>

        <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />
    </div>
</template>

<script>
import { getRate, delRate } from '@/api/settlement/rate'
import { allOrg } from '@/api/system/store'
import { insertSettlementBill, listFactorySettlement, listSettlementBill, confirmSettlementByFactory } from '@/api/settlement/bill'

export default {
    name: 'billSettlementFactory',
    // computed: {
    //   factory() {
    //     return factory
    //   }
    // },
    dicts: ['settlement_status_type'],
    data() {
        return {
            monthTime: '',
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 结算费率表格数据
            billList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 查询参数
            queryParams: {
                pageNum: 1,
                pageSize: 10,
                title: null
            },
            // 表单参数
            form: {},
            // 表单校验
            rules: {
                title: [{ required: true, message: '账单标题不能为空', trigger: 'blur' }]
            }
        }
    },
    created() {
        this.billId = this.$route.params.billId
        this.queryParams.billId = this.billId
        this.getList()
    },
    methods: {
        /** 查询结算费率列表 */
        getList() {
            this.loading = true
            this.queryParams.monthTime = this.monthTime
            listFactorySettlement(this.queryParams).then((response) => {
                this.billList = response.data.records
                this.total = response.data.total
                this.loading = false
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                sourceType: null,
                orgId: null,
                factoryRate: null,
                materialRate: null,
                manageRate: null,
                depositRate: null,
                otherStoreRate: null,
                payRate: null
            }
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.queryParams.pageNum = 1
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.monthTime = null
            this.queryParams.monthTime = null
            this.resetForm('queryForm')
            this.handleQuery()
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加结算费率'
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id = row.id || this.ids
            getRate(id).then((response) => {
                this.form = response.data
                this.open = true
                this.title = '修改结算费率'
            })
        },
        /** 提交按钮 */
        submitForm() {
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    insertSettlementBill(this.form).then((response) => {
                        this.$modal.msgSuccess('新增成功')
                        this.open = false
                        this.getList()
                    })
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids
            this.$modal
                .confirm('是否确认删除结算费率编号为"' + ids + '"的数据项？')
                .then(function () {
                    return delRate(ids)
                })
                .then(() => {
                    this.getList()
                    this.$modal.msgSuccess('删除成功')
                })
                .catch(() => {})
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'mapi/settlement/rate/export',
                {
                    ...this.queryParams
                },
                `rate_${new Date().getTime()}.xlsx`
            )
        },
        checkClose(done) {
            this.$confirm('是否关闭表单，关闭后数据将丢失？')
                .then(function () {
                    done()
                })
                .then(() => {})
                .catch(() => {})
        },
        confirmSettlement(row) {
            this.$confirm('该工厂：' + row.orgName + '，是否确认完成清算?')
                .then(() => {
                    confirmSettlementByFactory({ id: row.id }).then((response) => {
                        this.$modal.msgSuccess('操作成功')
                        this.getList()
                    })
                })
                .catch(() => {})
        }
    }
}
</script>
